// frame types
#define API_APIWSEND64	0x00	// same as 15_4
#define API_APIWSNDSTS	0x89	// same as 15_4
//#define API_APIWRECV64	0x80
#define API_APIWSNDIP4	0x20
#define API_APIWRCVIP4	0xB0
#define API_APIWRMTCMD	0x07
#define API_APIWRMTRSP	0x87
#define API_APIWIORECV	0x8F

// send options
#define WSO_NOACK	0x01

// receive options

// send status
#define WSS_SUCCESS	0x00
#define WSS_PURGED	0x03
#define	WSS_HWERR	0x04
#define	WSS_TX64NOACK	0x21
#define	WSS_RSRCERR	0x32
#define WSS_TOOLARGE	0x74
#define	WSS_SCKTERR	0x76


// IPv4 protocol
#define IP4_PROTO_UDP	0
#define IP4_PROTO_TCP	1

// send IPv4 options
#define IP4SOP_TCP_TERM	0x02

// receive IPv4 status

// remote command options
// in apicommon.h
// only RCO_APPLY is valid

// [remote] command response status
// in apicommon.h

// I/O sample receive options


typedef struct {
	unsigned char frameid;
	unsigned char addr[8];
	unsigned char options;
	unsigned char data;
} APIwsend64;

typedef struct {
	unsigned char frameid;
	unsigned char status;
} APIwsendsts;

/*
typedef struct {
	unsigned char addr[8];
	unsigned char rssi;
	unsigned char options;
	unsigned char data;
} APIwrecv64;
*/

typedef struct {
	unsigned char frameid;
	unsigned char addr[4];
	unsigned char dport[2];
	unsigned char sport[2];
	unsigned char proto;
	unsigned char options;
	unsigned char data;
} APIwsndip4;

typedef struct {
	unsigned char addr[4];
	unsigned char dport[2];
	unsigned char sport[2];
	unsigned char proto;
	unsigned char status;
	unsigned char data;
} APIwrcvip4;

#include "IOdata.h"
typedef struct {
	unsigned char samples;
	unsigned char digchannel[2];
	unsigned char anchannel;
	IOdata iodata;
} APIwiorecv;

typedef struct {
	unsigned char addr64[8];
	unsigned char rssi;
	unsigned char options;
	APIwiorecv data;
} APIwiorecvw;

typedef struct {
	unsigned char frameid;
	unsigned char addr64[8];
	unsigned char options;
	unsigned char cmd[2];
	unsigned char param;
} APIwrmtcmd;

typedef struct {
	unsigned char frameid;
	unsigned char addr64[8];
	unsigned char cmd[2];
	unsigned char status;
	unsigned char data;
} APIwrmtrsp;

