#include <stdio.h>

#include "apiframe.h"
#include "apicommon.h"
#include "apiwf.h"
#include "monlib.h"
#include "monlibwf.h"

int efede;

int TX(unsigned char data)
{
}

int RX()
{
unsigned char c;
  
  if(read(efede,&c,1)<=0)  // wait for a char in serial input
    return(-1);
  else return(c);
}



main (int argc, char *argv[])
{

int ret;
static APIstruct api,apirx;
static APIdata rxdata;
APIinfo *info;
APIstatus *sts;
APIcommand *cmd;
APIresponse *resp;
APIwrmtcmd *rcmd;
APIwrmtrsp *rresp;
APIwsend64 *ws64;
APIwsndip4 *ws;
APIwsendsts *wssts;
APIwrcvip4 *wr;
APIwiorecv *wior;
APIwiorecvw *wiorw;
unsigned char escape;
int pspeed=0;


    if(argc!=4){
      fprintf(stderr,"usage: %s mode port speed\n",argv[0]);
      fprintf(stderr,"\tmode=1: escaped chars\n\tmode=0: non-escaped chars\n");
      exit (-1);
    }
    escape=(*argv[1]=='1');
    pspeed=atoi(argv[3]);
    if(pspeed){
      efede=set_up_comms(argv[2],pspeed,"none");
      /* disable buffering so we can see output in realtime */
      setvbuf(stdout,(char *)NULL,_IONBF,0);
    }
    else exit(-1);
    
  API_initgettingframe(&apirx);

  while(1){
    while((ret=API_getframe(&apirx,escape))<=0)
	sleep(1);
    rxdata.len=ret;
    memcpy(&rxdata.info,&apirx.frame.info,ret);
    API_initgettingframe(&apirx);
    info=&rxdata.info;
    printf("\nRX: ");
    prdata((unsigned char *)info,rxdata.len,PRDATA_ASCII);
    printf("\n");
    switch(info->id){
    case API_APISTATUS:
      sts=(APIstatus *)&info->data;
      printf("Status frame: %s (%02X)\n",prsts(sts->status),sts->status);
      break;
    case API_APIQCOMMAND:
      printf("Queue ");
    case API_APICOMMAND:
      cmd=(APIcommand *)&info->data;
      printf("Command frame: ID: %02X CMD: %c%c PARAM: ",cmd->frameid,cmd->cmd[0],cmd->cmd[1]);
      prdata(&cmd->param,rxdata.len-4,0);
      printf("\n");
      break;
    case API_APIRESPONSE:
      resp=(APIresponse *)&info->data;
      printf("Command Response frame: ID: %02X STS: %s (%02X) DATA: ",resp->frameid,prrst(resp->status),resp->status);
      prdata(&resp->data,rxdata.len-5,0);
      printf("\n");
      break;
    case API_APIWRMTCMD:
      rcmd=(APIwrmtcmd *)&info->data;
      printf("Remote Command frame: ID: %02X\n",rcmd->frameid);
      pripaddr(&rcmd->addr64[4]);
      if(rcmd->options&RCO_APPLY)
	printf("\nAPPLY ");
      else
	printf("\n");
      printf("CMD: %c%c PARAM: ",rcmd->cmd[0],rcmd->cmd[1]);
      prdata(&rcmd->param,rxdata.len-4,0);
      printf("\n");
      break;
    case API_APIWRMTRSP:
      rresp=(APIwrmtrsp *)&info->data;
      printf("Remote Command Response frame: ID: %02X\n",rresp->frameid);
      pripaddr(&rresp->addr64[4]);
      printf("STS: %s (%02X) DATA: ",prrst(rresp->status),rresp->status);
      prdata(&rresp->data,rxdata.len-13,0);
      printf("\n");
      break;
    case API_APIWSEND64:
      ws64=(APIwsend64 *)&info->data;
      printf("Data Send, 64-bit address: ID: %02X ADDR: ",ws64->frameid);
      prdata(ws64->addr,8,1);
      printf("(%s)\n",pripaddr(&ws64->addr[4]));
      printf("OPT: %s (%02X) DATA: ",prwsop(ws64->options),ws64->options);
      prdata(&ws64->data,rxdata.len-11,0);
      printf("\n");
      break;
    case API_APIWSNDIP4:
      ws=(APIwsndip4 *)&info->data;
      printf("Data Send IPv4, ID: %02X,",ws->frameid);
      pripaddr(ws->addr);
      printf("\nDPT: %u SPT: %u %s OPT: %s (%02X)\nDATA: ",(ws->dport[0]<<8)+ws->dport[0],(ws->sport[1]<<8)+ws->sport[1],ws->proto!=0?"TCP":"UDP",prws4op(ws->options),ws->options);
      prdata(&ws->data,rxdata.len-12,PRDATA_ASCII);
      printf("\n");
      break;
    case API_APIWSNDSTS:
      wssts=(APIwsendsts *)&info->data;
      printf("Send Status frame: ID: %02X STS: %s (%02X)\n",wssts->frameid,prwsst(wssts->status),wssts->status);
      break;
    case API_APIWRCVIP4:
      wr=(APIwrcvip4 *)&info->data;
      printf("Data Receive IPv4,");
      pripaddr(wr->addr);
      printf("\nDPT: %u SPT: %u %s STS: %02x\nDATA: ",(wr->dport[0]<<8)+wr->dport[1],(wr->sport[0]<<8)+wr->sport[1],wr->proto!=0?"TCP":"UDP",wr->status);
      prdata(&wr->data,rxdata.len-11,PRDATA_ASCII);
      printf("\n");
      break;
    case API_APIWIORECV:
      wiorw=(APIwiorecvw *)&info->data;
      wior=&wiorw->data;
      printf("I/O Data Receive,");
      pripaddr(&wiorw->addr64[4]);
      printf("\nOPT: %s (%02X)\n",prwrop(wiorw->options),wiorw->options);
      prwiodata(wior);
      break;
    default:
      printf("*** UNKNOWN FRAME\n");
    }
    printf("\n");
  }
}



